import sys
import math
from sys import stdout
from time import sleep
import usb
import subprocess
import re
import os

#############       

#Check MCU-Board
def find_board():
    for bus in usb.busses():
            for dev in bus.devices:
                if (dev.idVendor,dev.idProduct) == (0x16c0,0x05dc):
                    return dev
    return False
#Read Input From MCU-Board
def usb_read(handle, request, length):
    reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
    buf = handle.controlMsg(
            reqType, request, length)       
    return buf

#Script find id keyboard and mouse pad
def scanID(text):
    ID = re.split('=|\t',text)
    return ID[2]

def findID():
    #check already have file Key ID ??
    if not os.path.exists('ID.txt'):
        ID = open('ID.txt','w')
    subprocess.call(['xinput | grep "Translated" > ID.txt'],shell = True)#Write ID Keyboard to file ID
    subprocess.call(['xinput | grep "TouchPad" >> ID.txt'],shell = True)#Write ID Keyboard to file ID

def LockKey():
    files = open('ID.txt','r')
    lines = files.readline()
    while lines:
        UID = scanID(lines)
        subprocess.call(['xinput','set-prop',str(UID),'Device Enabled','0']) #Disabled Keyboard And Mouse
        lines = files.readline()
    files.close()

def UnLockKey():
    files = open('ID.txt','r')
    lines = files.readline()
    while lines:
        UID = scanID(lines)
        subprocess.call(['xinput','set-prop',UID,'Device Enabled','1']) #Enabled Keyboard And Mouse
        lines = files.readline()
    files.close()

###########################Start Program############################

locked = False
board = find_board()
handle = board.open()
light_value_old = 0
findID()
print 'Protect your computer And your eye'
light = raw_input('Start Program (y/n)? ')

if light == 'y' and not find_board():
    print "Can't Find Mcu-Board Please Check Your Board"
elif light == 'y' and find_board():
    os.system('sudo chmod 646 /sys/class/backlight/acpi_video0/brightness')#Change Permission file brightness to 646
    while light=='y' or find_board():
        #######Module Lock Computer#######
        if not find_board():#Board Not Found !!
            check = find_board()
            LockKey()
            locked = True
            os.system('clear')            
            print 'MCU Board not FOUND Lock Your Computer !!!!!'
            while not find_board():#lock until input your board
                stdout.write('Check Your MCU Board?\r')            
            sleep(0.5)
        if find_board() and locked:
            print 'FOUND Your MCU Board'
            print 'Unlock Your Computer'
            
            locked = False
            UnLockKey()
            board = find_board()
            handle = board.open()
            sleep(0.5)
            os.system('clear')
        ##################################
        light_value = usb_read(handle,2,1)
        light_value = light_value[0]/15
        if light_value_old == 0:
            light_value_old = light_value
        elif math.fabs(light_value-light_value_old) > 1:
            light_value_old = light_value
        print('Hold Switch On MCU-Board to Exit Program :: Light Value = %d'%(light_value_old))
        if usb_read(handle,1,1) == (1,):
            break
        os.system('echo %d > /sys/class/backlight/acpi_video0/brightness'%(light_value_old))#Change light value in system
        sleep(1)
    os.system('clear')
    print '###### Exit Program ######'
    os.system('sudo chmod 644 /sys/class/backlight/acpi_video0/brightness')#Change Permission file brightness to normal

